/* $Id$ */
/*========================================================================
 *  Copyright (c) Michael J. Hammel 1995,1996,1997,1998.
 *========================================================================
 *              FILE NAME: XNotesPlus.h
 *            DESCRIPTION: declarations for XNotesPlus.
 *  SOFTWARE DEPENDENCIES: gtk, gdk, glib, Xlib
 *  HARDWARE DEPENDENCIES: 
 *                  NOTES: 
 *
 * SPECIAL CONSIDERATIONS:
 * This file is easiest to read with tabstops set to 3
 *
 *========================================================================
 *
 * MODIFICATION HISTORY:
 * $Log$
 *
 *========================================================================*/
#ifndef XP_H
#define XP_H

/*
 * Default values.
 */
#define DefaultBufSize			1024
#define DefaultNameWidth		10
#define DefaultAnchorOffset	15
#define DefaultNoteDir			".xnotesplus"
#ifdef DO_MOTIF
#define DefaultProjectFile		"xnprojects"
#else
#define DefaultProjectFile		"xnprojects-gtk"
#endif
#define DefaultXPMDir			"xpm-d"
#define DefaultPilotDB			"xnaddress"
#define DefaultAddrDir			"addresses"
#define DefaultTmpDir			"/tmp"
#define DefaultPrintCmd			"lpr %s"
#define DefaultEmailCmd			"mail -s\"%s\" %s"
#define DefaultEmailAddr		""
#define DefaultCalendarCmd		"cal"
#define DefaultShCmd				"/bin/sh"
#define DefaultAudioCmd			"sox %s -t .au -v %d /dev/audio"
#define DefaultAudioDir			"audio"
#define DefaultRGBFile			"/usr/X11R6/lib/rgb.txt"
#define DefaultPilotDir			"pilot"
#define DefaultInterval			(60*60)
#define DefaultPlaidWidth		64
#define DefaultPlaidHeight		64
#define DefaultListWidth		64
#define DefaultListHeight		64
#define DefaultMaxNotes			255
#define DefaultConfigFile		"XNotesPlus.cfg"
#define DefaultGtkRC				"XNotesPlus.rc"
#define DefaultIdFile			"id"

#define DefaultPilotSync		"pilot-xfer"
#define DefaultPilotAddr		"pilot-addresses"
#define DefaultPilotMemos		"memos"
#define DefaultPilotIMemos		"install-memo"

#define XP_ALARM_ON_XPM			"alarmon.xpm"
#define XP_ALARM_OFF_XPM		"alarmoff.xpm"
#define XP_ANCHOR_XPM			"anchoron.xpm"
#define XP_ANCHOR_OFF_XPM		"anchoroff.xpm"
#define XP_BLANK_XPM				"blank.xpm"
#define XP_PLAID_XPM				"xnotes.xpm"
#define XP_MSG_XPM				"msg.xpm"
#define XP_INFO_XPM				"info.xpm"
#define XP_ERROR_XPM				"error.xpm"
#define XP_FILE_XPM				"file.xpm"
#define XP_NOTES_XPM				"notes.xpm"
#define XP_ENVELOPE_XPM			"postal.xpm"
#define XP_PILOT_XPM				"pilot.xpm"

/*
 * Post-It Note sizes.
 */
#define StickyNote_1p5x2	0
#define StickyNote_2x3		1
#define StickyNote_3x3		2
#define StickyNote_3x4		3
#define StickyNote_3x5		4
#define StickyNote_4x6		5

/*
 * Post-It Note file information.
 */
#define StickyNoteMagic			"%!<postitnote>"
#define StickyNoteMagic_v2		"%%!!<postitnote>"
#define StickyNoteMagic_v3		"%%!!<xpstickynote.v3>"
#define StickyProjMagic_v3		"%%!!<xpproj.v3>"
#define StickyNoteFname			"note"
#define StickyEnvelopeFname	"envelopes"

/*
 * Config file name/value delimeter.
 */
#define XP_DELIMITER			':'

/*
 * Application class.  Also the program name.
 */
#define StickyNoteClass		"XNotesPlus"
#define XP_S_PROG_NAME		StickyNoteClass
#define XP_S_ABOUT_INFO		"\n \nby\n \nMichael J.  Hammel\nmjhammel@graphics-muse.org\nhttp://www.graphics-muse.org"

/*
 * Menu ids - if you modify these, be sure to update the text arrays
 * in notes.c.
 */
#define XP_FILE_SAVE_ID					0
#define XP_FILE_OPEN_ID					1
#define XP_FILE_EXPORT_ID				2
#define XP_FILE_FIND_ID					3
#define XP_FILE_PRINT_ID				4
#define XP_FILE_EMAIL_ID				5
#define XP_OPTIONS_HIDE_ID				0
#define XP_OPTIONS_ERASE_ID			1
#define XP_OPTIONS_DESTROY_ID			2
#define XP_OPTIONS_NAME_ID				3
#define XP_OPTIONS_PROJ_ID				4
#define XP_OPTIONS_CALENDAR_ID		5
#define XP_OPTIONS_DATE_ID				6
#define XP_ALARM_ON_ID					0
#define XP_ALARM_OFF_ID					1
#define XP_ANCHOR_ON_ID					0
#define XP_ANCHOR_OFF_ID				1



/*========================================================================
 * Text strings - you can tell the historical naming convention changed.
 *=======================================================================*/

#define StickyNoteList				"Hidden Notes" 
#define NotesErrDialog				"XNotesPlus Error"
#define NotesAlarmDialog			"XNotesPlus Alarm"
#define NotesTimerPrompt			"Alarms Setup"
#define NotesAddrPrompt				"Print Envelopes"
#define AddrListPrompt				"Select an address"
#define NotesIOPrompt				"File Selection Window"
#define NotesPilotBUPrompt			"Select Pilot Backup Directory"
#define NotesInsertPrompt			"Insert Date"
#define NotesFindPrompt				"Find A Note"
#define NotesEmailPrompt			"Email Note"
#define NotesOptionsMenu			"OptionsMenu"
#define NotesFileMenu				"FileMenu"
#define StickyNoteDialog			"Title for Note"
#define NotesSaveOnExitPrompt		"Save Notes"
#define NotesConfirmDialog			"Confirm"
#define NotesHelpDialog				"Help"
#define ProjectDialog				"Projects"
#define ProjectNoteDialog			"Change Project"
#define FindTextDialog				"Search"
#define PilotDialog					"PalmPilot Interface"
#define RenameDirDialog				"Rename Directory"
#define AboutDialog					"About XNotesPlus"

#define XP_ERROR_TITLE				"XNotes Error"
#define XP_MSG_TITLE					"XNotes Message"
#define XP_INFO_TITLE				"XNotes Info"
#define XP_CONFIRM_TITLE			"XNotes Confirmation"

#define XP_FILE_LABEL				"File"
#define XP_NOTES_LABEL				"Notes"
#define XP_FILE_SAVE					"Save..."
#define XP_FILE_OPEN					"Open..."
#define XP_FILE_EXPORT				"Export..."
#define XP_FILE_FIND					"Find..."
#define XP_FILE_PRINT				"Print"
#define XP_FILE_EMAIL				"Email..."
#define XP_OPTIONS_HIDE				"Hide"
#define XP_OPTIONS_ERASE			"Erase"
#define XP_OPTIONS_DESTROY			"Destroy"
#define XP_OPTIONS_NAME				"Name..."
#define XP_OPTIONS_PROJECT			"Project..."
#define XP_OPTIONS_ANCHOR			"Anchor"
#define XP_OPTIONS_NOANCHOR		"Unanchor"
#define XP_OPTIONS_ALARM			"Set Alarm..."
#define XP_OPTIONS_NOALARM			"Unset Alarm"
#define XP_OPTIONS_CALENDAR		"Insert Calendar"
#define XP_OPTIONS_DATE				"Insert Date"
#define XP_ALARM_ON					"Set Alarm"
#define XP_ALARM_OFF					"Disable Alarm"
#define XP_ANCHOR_ON					"Set Anchor"
#define XP_ANCHOR_OFF				"Disable Anchor"

#define XP_S_CONFIRM					"Confirm"
#define XP_S_ACCEPT					"Accept"
#define XP_S_CANCEL					"Cancel"
#define XP_S_OK						"OK"
#define XP_S_TOGGLE					"Toggle"
#define XP_S_CLOSE					"Close"
#define XP_S_SAVE						"Save"
#define XP_S_LOAD						"Load"
#define XP_S_PRINT					"Print"
#define XP_S_YES						"Yes"
#define XP_S_NO						"No"
#define XP_S_NEXT						"Next"
#define XP_S_PREV						"Previous"
#define XP_S_HOME						"Home"
#define XP_S_SET_TIME				"Set Time"
#define XP_S_CURRENT_TIME			"Last Setting"
#define XP_S_SET_AUDIO				"Select Audio To Play"
#define XP_S_NO_AUDIO				"NONE"
#define XP_S_NO_PROJECT				"NONE"
#define XP_S_FROM_ADDR				"From:"
#define XP_S_TO_ADDR					"To:"
#define XP_S_PT_SIZE					"Pt. Size"
#define XP_S_ENV_TYPE				"Envelope Type"
#define XP_S_PRINTER					"Printer Command"
#define XP_S_PRINTER_NAME			"Name of printer to use"
#define XP_S_IMPORT					"Import"
#define XP_S_EXPORT					"Export"
#define XP_S_FETCH					"Fetch"
#define XP_S_PROCESS					"Process"
#define XP_S_CASE						"Case Sensitive"
#define XP_S_DIRECTION				"Search Backwards"
#define XP_S_SEARCH_PROMPT			"Enter text to search for:"
#define XP_S_NOT_FOUND				"No further occurances of string\nin that direction."

#define XP_S_PILOT_ADDR				"Pilot Addresses"
#define XP_S_PILOT_MEMOS			"Pilot Memos"
#define XP_S_PILOT_SYNC				"Pilot Sync"
#define XP_S_PILOT_MODE				"Mode"
#define XP_S_PILOT_START			"Start Transfer"
#define XP_S_PILOT_REMOVE			"Remove Dir"
#define XP_S_PILOT_RENAME			"Rename Dir"

#define XP_S_PILOT_HOTSYNC			"Press the HotSync button on the Pilot's cradle now.\nThen click the Accept button to start the transfer."

#define XP_S_UNKNOWN_CAT			"You need to add the \"xnotes\" category to the Pilot\nbefore trying to upload an XNote to it."

#define XP_S_DESTROY_CONFIRM		"Do you really want\nto destroy this note?"
#define XP_S_NO_NOTES				"You have no notes."
#define XP_S_NO_HIDDEN_NOTES		"There are no hidden notes."
#define XP_S_NO_NOTES_TO_RAISE	"There are no notes to raise."
#define XP_S_NO_NOTES_TO_HIDE		"There are no notes to hide."
#define XP_S_NO_NOTES_TO_UNHIDE	"There are no notes to unhide."
#define XP_S_NO_NOTES_TO_LOWER	"There are no notes to lower."
#define XP_S_NO_ANCHORED_NOTES	"There are no anchored notes."
#define XP_S_FILE_EXIST				"File already exists.  Overwrite?"
#define XP_S_NOTE_PTR_MISSING		"Can't fine associated note structure!"
#define XP_S_EXPIRED_1				"The alarm has expired for the Note\n"
#define XP_S_EXPIRED_2				"with the following name:\n"
#define XP_S_CANT_RUN_CMD			"Couldn't run %s: return code = %d" 
#define XP_S_CANT_RUN_CMD2			"Couldn't run %s: return code = unknown" 
#define XP_S_EMAIL					"Enter the email address of the intended recipient"
#define XP_S_NO_TEXT_TO_PRINT		"No text in note to print!"
#define XP_S_TEMP_OPEN_FAIL		"Can't open tempoary file for\nwriting: %s"
#define XP_S_DEFAULT_NOTE_TITLE	"Untitled Note"
#define XP_S_NO_CONFIG_FILE		"%s: Can't find config file %s.\n"
#define XP_S_SAVE_NOTES				"Save Changed Notes?  "
#define XP_S_FIND_FAIL				"Can't find string: "
#define XP_S_NO_RGB					"Could not read rgb.txt file!"

#define XP_S_MSG_BAD_VISUAL		"Unsupported visual.  Can't run with < 256 colors."

#define XP_S_MSG_LIMITED_VISUAL	"You're visual has limited color capabilities.\nYou may encounter problems with colors"

#define XP_S_CANT_CONV_COLOR		"Sorry, but that color doesn't\nseem to be available for some reason."

#define XP_S_CANT_FIND_PROJ		"Can't find that project!"
#define XP_S_SAMPLE_NOTE			"Sample Note Text"

#define XP_S_DISABLE_CMDS			"The following features have been disabled because either the \nconfigured external application for them could not be \nlocated in your path or a needed data file could not be found:\n\n"

#define XP_S_DISABLE_PRINT			"Printing\n"
#define XP_S_DISABLE_CAL			"Calendar Insert\n"
#define XP_S_DISABLE_EMAIL			"Email Notes\n"
#define XP_S_DISABLE_AUDIO			"Audio alarms\n"
#define XP_S_DISABLE_PROJECTS		"Note Projects\n"
#define XP_S_LIST_EMPTY				"You must select items from the list first."

#define XP_S_DISABLE_PILOT_PORT	"\nThe environment variable PILOTPORT must be set in order to\nuse the Pilot Tool feature.  You should set this to the\nserial port (/dev/cua, for example) to which the Pilot\ncradle is connected.\n"

#define XP_S_DISABLE_PILOT_PORT2	"\nThe environment variable PILOTPORT specifies a device\nthat can't be opened.  Access to the Pilot tools has\n been disabled.\n"

#define XP_S_DISABLE_PILOT_RATE	"\nThe environment variable PILOTRATE should be set in order to\nuse the Pilot Tool feature.  You should set this to any high\nbaud rate, such as 57600.\n"

#define XP_S_DISABLE_PILOT_SYNC	"Pilot Sync\n"
#define XP_S_DISABLE_PILOT_ADDR	"Pilot Addresses\n"
#define XP_S_DISABLE_PILOT_MEMOS	"Pilot Memos\n"
#define XP_S_COLOR_CHOICES			"Colors"
#define XP_S_PROJ_CHOICES			"Projects"
#define XP_S_PROJ_UPD				"Project has been updated."
#define XP_S_DELETE_PROMPT			"Delete directory %s?"
#define XP_S_PILOT_MENU_BU			"Backup all files from Pilot"
#define XP_S_PILOT_MENU_RESTORE	"Restore existing backup"
#define XP_S_PILOT_MENU_SYNC		"Sync backups with Pilot"
#define XP_S_PILOT_MENU_UPDATE	"Update backups from Pilot"
#define XP_S_PILOT_IMEMO_OK		"Memos uploaded to Pilot successfully."
#define XP_S_PILOT_MEMO_OK			"Memos downloaded from Pilot successfully."
#define XP_S_PILOT_SYNC_OK			"Pilot backed up/synced successfully."
#define XP_S_PILOT_ADDR_OK			"Pilot Address database\nretrieved successfully."

#define XP_S_PTITLE_MEMO			"# Temporary script to download memos from a PalmPilot.\n"

#define XP_S_PTITLE_IMEMO			"# Temporary script to install notes into Memos database on a PalmPilot.\n"

#define XP_S_PTITLE_ADDR			"# Temporary script to retrieve Address database from a PalmPilot.\n"

#define XP_S_PTITLE_SYNC			"# Temporary script to backup a PalmPilot.\n"

#define XP_S_PATH_INVALID			"The directory path must be fully qualified."
#define XP_S_RENAME_FAIL			"Failed to rename directory %s\nto %s.\nerrno=%d"

#define XP_S_LOCDB_FAIL				"Failed to read local Address databases."

#define XP_S_ENABLE_TIPS			"Enable Tool Tips"
#define XP_S_DISABLE_TIPS			"Disable Tool Tips"

#define XP_S_PRT_MISSING			"You must provide a printer name to print envelopes."
#define XP_S_PRT_FROM				"You must provide a \"From\" address\nto print envelopes."
#define XP_S_PRT_TO					"You must provide a \"To\" address\nto print envelopes."

#define XP_S_REPEAT_TEXT			"Repeat"
#define XP_S_MONTH					"Month"
#define XP_S_DAY						"Day"
#define XP_S_HOUR						"Hour"
#define XP_S_MIN						"Min"


/*
 * Help Message
 */
#define USAGE \
"\n\
xnotes+ [ -c | --sb | --sv | --ns | --na | --help/-?/-h | --bs bufsize \n\
         | --notedir notedir | --interval seconds | --nw pixels \n\
         | --ao pixels | --tmpdir tmpdir | --printcmd cmd | --emailcmd cmd \n\
         | --calendarcmd cmd | --homedir path | --xpmdir dir \n\
         | --audiocmd cmd | --audiodir dir | --noaudio | --addrdir dir \n\
         | --pilotdir dir | --rgbfile path | --defaults | --install \n\
         | --version ]\n\
where\n\
    -c                   turns on compatibility mode\n\
    --sb                 turns on scrollbars for all notes\n\
    --sv                 enables save-on-exit\n\
    --ns                 disables the auto save feature\n\
    --na                 disables the alarm feature\n\
    --nn                 disables the dialog showing disabled features\n\
    --help | -? | -h     prints this help message\n\
    --bs bufsize         sets the buffer size for all notes\n\
    --notedir notedir    specifies the directory to load and save notes\n\
    --interval minutes   specifies the auto-save timeout value\n\
    --nw pixels          width, in pixels, of a single character\n\
    --ao offset          offset, in pixels, for X,Y coords of cascaded notes\n\
    --tmpdir tmpdir      directory to use for temporary files\n\
    --printcmd cmd       print command (use %%s for filename)\n\
    --emailcmd cmd       command to use to send email (use %%s for filename)\n\
    --calendarcmd cmd    calendar command\n\
    --homedir path       default home directory (used by file selection \n\
                         window\n\
    --xmpdir dir         where XNotesPlus bitmaps can be found\n\
    --audiocmd cmd       command to run audio files (use %%s for audio file)\n\
    --audiodir dir       where audio files are stored\n\
    --noaudio            disable audio for alarms\n\
    --addrdir dir        where address files are stored\n\
    --rgbfile path       fully qualified path to rbg.txt file\n\
    --pilotdir           directory to save PalmPilot backups to\n\
\n\
    --defaults           show configured defaults for all parameters\n\
    --notips             don't show tool tips\n\
    --install            install a private colormap (for low color displays)\n\
    --version            print the current version number\n\
\n\
"

/*========================================================================
 * Configuration file tokens
 *=======================================================================*/
#define XP_CFG_HOME						"HOMEDIR"
#define XP_CFG_NOTEDIR					"NOTEDIR"
#define XP_CFG_TMPDIR					"TMPDIR"
#define XP_CFG_XPMDIR					"XPMDIR"
#define XP_CFG_AUDIODIR					"AUDIODIR"
#define XP_CFG_PILOTDIR					"PILOTDIR"
#define XP_CFG_ADDRDIR					"ADDRDIR"

#define XP_CFG_NOAUDIO					"NOAUDIO"
#define XP_CFG_AUTOSAVE_INTERVAL		"SAVEINTERVAL"
#define XP_CFG_SAVEEXIT					"SAVEEXIT"
#define XP_CFG_AUTOSAVE					"AUTOSAVE"
#define XP_CFG_ALARM						"ALARM"
#define XP_CFG_NOSAVE					"NOSAVE"

#define XP_CFG_GTKRC						"GTKRC"

#define XP_CFG_AUDIO						"AUDIOCMD"
#define XP_CFG_CAL						"CALENDARCMD"
#define XP_CFG_EMAIL						"EMAILCMD"
#define XP_CFG_EMAIL_ADDR				"EMAILADDR"
#define XP_CFG_PRINT						"PRINTCMD"

/* State types */
#define XP_CFG_ON							"ON"
#define XP_CFG_OFF						"OFF"
#define XP_CFG_YES						"YES"
#define XP_CFG_NO							"NO"


/*========================================================================
 * Numeric symbols
 *=======================================================================*/

/*
 * Request for a new note index number.
 */
#define NewIndex				-1

/*
 * Types for the InsertText() and FillList() functions
 */
#define TEXT_TYPE				0
#define FILE_TYPE				1
#define DIR_TYPE				2

/*
 * Types for the CreateIOPrompt() function
 */
#define XNOTES_OPEN_FILE		0
#define XNOTES_EXPORT_FILE		1

/*
 * Just in case.
 */
#ifndef MAXPATHLEN
#define MAXPATHLEN			1024
#endif

/*
 * Maximum number of directory files we can handle
 */
#define XP_MAX_FILES			1024

/*
 * Alarm timeout periods (in seconds, generally).
 */
#define XP_ALARM_PERIOD				60

/*
 * Maximum width (in characters) for a line of an error dialog message.
 */
#define XP_MAX_ERR_TEXT_LENGTH	80

/*
 * Maximum width (in characters) for a line of a confirm dialog message.
 */
#define XP_MAX_CONFIRM_TEXT_LENGTH	80

/*
 * Maximum width in characters for alarm notifications.
 */
#define XP_MAX_ALARM_NOTIFY_LENGTH	80

/*
 * Width and height of the Find a Note list.
 */
#define XP_FIND_WIDTH				250
#define XP_FIND_HEIGHT				250

/*
 * Width and height of the Address list.
 */
#define XP_ADDR_WIDTH				XP_FIND_WIDTH
#define XP_ADDR_HEIGHT				XP_FIND_HEIGHT

/*
 * Width and height of the Project list.
 */
#define XP_PROJ_WIDTH				220
#define XP_PROJ_HEIGHT				100

/*
 * Width and height of audio lists.
 */
#define XP_AUDIO_WIDTH				100
#define XP_AUDIO_HEIGHT				100


/*
 * Buttons to use in generic shell widgets.  There are gaps in here, but
 * thats not important right now.
 */
#define ACCEPT_BUTTON		0x0001   /* accepts input and begins processing */
#define CANCEL_BUTTON		0x0002   /* used to close windows */
#define OK_BUTTON				0x0004   /* displays "OK" instead of "Accept" */
#define OVERWRITE_BUTTON	0x0008   /* overwrites a file */
#define APPEND_BUTTON		0x0010   /* appends to a file */
#define HELP_BUTTON			0x0020   /* opens help window */
#define PRINT_BUTTON			0x0040   /* same as "accept", but displays "Print" */
#define YES_BUTTON			0x0080   /* same as "accept", but displays "Yes" */
#define CLOSE_BUTTON			0x0100   /* same as "Cancel" but w/different text */
#define NO_BUTTON				0x0200   /* same as "Cancel" but w/different text */
#define SEARCH_BUTTON		0x0400   /* same as "accept" but w/different text */
#define ALL_BUTTON			0x0fff   /* never used */
 
/*
 * Message Window types
 */
#define XP_ERROR_TYPE		0x0001
#define XP_MSG_TYPE			0x0002
#define XP_INFO_TYPE			0x0004
#define XP_CONFIRM_TYPE		0x0008
#define XP_MSG_NOCANCEL		0x0100
#define XP_MSG_NOHELP		0x0200
#define XP_MSG_NOOK			0x0400

/*
 * Pilot types (used by pilot.c:FetchPilot())
 */
#define XP_PILOT_MEMO		0
#define XP_PILOT_INST		1
#define XP_PILOT_ADDR		2
#define XP_PILOT_SYNC		3

/*
 * Project types (for GTK version's calls to XPProject())
 */
#define XP_PROJ_CONFIG		1
#define XP_PROJ_USER			2

/*
 * Tool Tip states
 */
#define XP_TIPS_OFF			0
#define XP_TIPS_ON			1

/*
 * XPConvertCase types
 */
#define XP_LOWER				1
#define XP_UPPER				2

/*
 * Directional types
 */
#define XP_FORWARD			1
#define XP_BACKWARD			2

/*========================================================================
 * Error Codes
 *=======================================================================*/
#define XP_E_SUCCESS					0
#define XP_E_FAILURE					1

#define XP_E_FILE_EXIST				2

/*
 * Colormap handling return codes - see colors.c
 */
#define XP_VISUAL_NOT_SUPPORTED		100
#define XP_CMAP_SMALL_IMMUTABLE		101
#define XP_CMAP_BIG_IMMUTABLE			102
#define XP_CMAP_OK						103



/*========================================================================
 * Tool Tips - the order of these needs to be the same - the IDs map to
 * the text strings in a static character array in tooltips.c
 *=======================================================================*/
#define XP_TTID_DIR					0
#define XP_TTID_PRJ_TEXT			1
#define XP_TTID_AUDIO_REP			2
#define XP_TTID_AUDIO_TOG			3
#define XP_TTID_PILOT_ADDR			4
#define XP_TTID_PILOT_MFET			5
#define XP_TTID_PILOT_MPRO			6
#define XP_TTID_PILOT_MEMO			7
#define XP_TTID_ENV_SAVE_FROM		8
#define XP_TTID_ENV_LOAD_TO		9
#define XP_TTID_PRJ_SAVE			10
#define XP_TTID_PRJ_CANCEL			11

#define XP_S_TT_DIR			"Select a Directory"
#define XP_S_TT_PRJ_TEXT	"Enter or change the\nname of the project"
#define XP_S_TT_AUDIO_REP	"Number of times to play\nthe audio file when\nthe alarm sounds."
#define XP_S_TT_AUDIO_TOG	"Resets all fields\nto current time."
#define XP_S_TT_PILOT_ADDR	"Retrieve Address database\nfrom Pilot"
#define XP_S_TT_PILOT_MFET	"Import: Retrieve memos from Pilot\nExport: Get list of available xnotes"
#define XP_S_TT_PILOT_MPRO	"Import: Convert selected memos into xnotes\nExport: Send selected xnotes to Pilot as memos"
#define XP_S_TT_PILOT_MEMO	"Use Fetch to retrieve xnotes(Export toggle) or\nPilot's memos (Import toggle).  Select items of\ninterest, then use Process to convert to memos\n(Export toggle) or xnotes (Import toggle)."
#define XP_S_TT_ENV_SAVE_FROM "Save text to your id file."
#define XP_S_TT_ENV_LOAD_TO 	\
"Allows you to select from Pilot's\nAddress list, if available. Use the Pilot Tool\n\"Address Fetch\" first to get the list."
#define XP_S_TT_PRJ_SAVE 	"Save changes, but keep window open."
#define XP_S_TT_PRJ_CANCEL "Close window. Any changes not\nsaved previously will be lost."

/*========================================================================
 * Macros
 *=======================================================================*/
#ifdef DO_GTK
#include "xngtk.h"
#endif


/*========================================================================
 * Type definitions
 *=======================================================================*/

/*
 * The Post-It Note record.  One of these is allocated
 * for each note created.
 */

#ifdef DO_GTK
/*
 * The GTK version of the StickyNote structure.
 */
typedef struct _StickyNote {
	GtkWidget	*pn_shellwidget;		/* shell widget holding it all	*/
	GtkWidget	*pn_labelwidget;		/* label widget */
	GtkWidget	*pn_savewidget;		/* save widget */
	GtkWidget	*pn_alarmwidget;		/* alarm button */
	GtkWidget	*pn_alarm_pixmapid;	/* alarm pixmap */
	GtkWidget	*pn_anchor_pixmapid;	/* anchor pixmap */
	GtkWidget	*pn_options;			/* options button widget */
	GtkWidget	*pn_optionsmenu;		/* options menu widget */

	GtkWidget	*pn_filebutton; 		/* file button widget */
	GtkWidget	*pn_filemenu; 			/* file menu widget */

	GtkWidget	*pn_textwidget;		/* text widget of the note	*/
	GtkWidget	*pn_texthbox;			/* text widget parent */
	GtkWidget	*pn_scrollwidget;		/* scroll bar for text */
	GtkWidget	*pn_anchorwidget;		/* menu widget for "Anchor" option */
	GtkWidget	*pn_unanchorwidget;	/* menu widget for "UnAnchor" option */
	GtkWidget	*pn_settimewidget;	/* menu widget for "Set Alarm" option */
	GtkWidget	*pn_unsettimewidget;	/* menu widget for "Unset Alarm" option */

	GString	*pn_file;		/* file note will be saved in	*/
	char		*pn_text;		/* buffer holding text of note	*/
	GString	*pn_name;		/* name of note	*/
	char		*pn_project;	/* project id - TBD */
	int		pn_type;			/* Note type: traditional, memo, todo - TBD */

	gint	pn_index;			/* index number of note		*/
	gint	pn_hide_index;		/* index used when note is hidden */
	gint	pn_shellx;			/* x coord of shell widget	*/
	gint	pn_shelly;			/* y coord of shell widget	*/
	gint	pn_textsize;		/* size of pn_text in chars	*/
	gint	pn_textwidth;		/* width of text widget window	*/
	gint	pn_textheight;		/* height of text widget window	*/

	gint	pn_alarm_mon;		/* alarm month (0-11) */
	gint	pn_alarm_day;		/* alarm day (0-31) */
	gint	pn_alarm_hour;		/* alarm hour (0-23) */
	gint	pn_alarm_min;		/* alarm minute (0-59) */
	char	*pn_alarm_audio;	/* audio file for alarms */
	gint	pn_alarm_repeat;	/* number of times to repeat alarm */
	gint	pn_alarm_volume;	/* alarm volume */

	gboolean	pn_positionit;	/* true if shellx/shelly valid	*/
	gboolean	pn_hidden;		/* true if note is currently hidden */
	gboolean	pn_saved;		/* false=save button sensitive	*/
	gboolean	pn_anchor;		/* true if note is an anchor note */
	gboolean	pn_alarm;		/* true if notes alarm is set */

	struct	_StickyNote *pn_next;	/* pointer to next note record	*/
} StickyNote;

#else

/*
 * The Motif version of the StickyNote structure.
 */
typedef struct _StickyNote {
	Widget		pn_shellwidget;		/* shell widget holding it all	*/
	Widget		pn_labelwidget;		/* label widget */
	Widget		pn_savewidget;			/* save widget */
	Widget		pn_alarmwidget;		/* alarm button */
	Widget		pn_anchorwidget;		/* anchor button */
	Pixmap		pn_alarm_pixmapid;	/* alarm pixmap */
	Widget		pn_options;				/* options button widget */
	Widget		pn_optionsmenu;		/* options menu widget */

	Widget		pn_filebutton; 		/* file button widget */
	Widget		pn_filemenu; 			/* file menu widget */

	Widget		pn_textwidget;			/* text widget of the note	*/
	Widget		pn_anchormenu;			/* menu widget for "Anchor" option */
	Widget		pn_unanchormenu;		/* menu widget for "UnAnchor" option */
	Widget		pn_settimewidget;		/* menu widget for "Set Alarm" option */
	Widget		pn_unsettimewidget;	/* menu widget for "Unset Alarm" option */

	char		*pn_file;		/* file note will be saved in	*/
	char		*pn_text;		/* buffer holding text of note	*/
	char		*pn_name;		/* name of note	*/
	char		*pn_project;	/* project id - TBD */
	int		pn_type;			/* Note type: traditional, memo, todo - TBD */

	int	pn_index;			/* index number of note		*/
	int	pn_hide_index;		/* index used when note is hidden */
	int	pn_shellx;			/* x coord of shell widget	*/
	int	pn_shelly;			/* y coord of shell widget	*/
	int	pn_textsize;		/* size of pn_text in chars	*/
	int	pn_textwidth;		/* width of text widget window	*/
	int	pn_textheight;		/* height of text widget window	*/

	int	pn_alarm_mon;		/* alarm month (0-11) */
	int	pn_alarm_day;		/* alarm day (0-31) */
	int	pn_alarm_hour;		/* alarm hour (0-23) */
	int	pn_alarm_min;		/* alarm minute (0-59) */
	char	*pn_alarm_audio;	/* audio file for alarms */
	int	pn_alarm_repeat;	/* number of times to repeat alarm */
	int	pn_alarm_volume;	/* alarm volume */

	Boolean	pn_positionit;	/* true if shellx/shelly valid	*/
	Boolean	pn_hidden;		/* true if note is currently hidden */
	Boolean	pn_saved;		/* false=save button sensitive	*/
	Boolean	pn_anchor;		/* true if note is an anchor note */
	Boolean	pn_alarm;		/* true if notes alarm is set */

	struct	_StickyNote *pn_next;	/* pointer to next note record	*/
} StickyNote;
#endif

/*
 * Envelopes.
 */
typedef struct _StickyEnvelope {
	int		env_id;			/* unique id */
	char		*text;			/* text for envelope */

	struct _StickyEnvelope	*env_next;	/* ptr to next envelope record */
} StickyEnvelope;


/*
 * The resource record, for holding resources specific to xnotes.
 */
typedef struct {
	int		buf_size;		/* size of pn_text to be used	*/
	int		interval;		/* auto-save interval (in minutes) */
	char		scroll_ovf;		/* NOT USED ANYMORE */
	char		scroll_bar;		/* turn on scroll bars */
	char		save_notes;		/* save notes on exit */
	char		compatibility;	/* maintain prev version compatibility */
	char		nosave;			/* don't do auto-save */
	char		noalarm;			/* don't do alarms */
	char		nonotice;		/* don't show dialog about disabled functions */
	char		help;				/* provide usage message */
	char		defaults;		/* Show the configured defaults */
	char		version;			/* provide version information */
	int		name_width;		/* used	in calculating width of dialog */
	int		anchor_offset;	/* used in cascading notes */
	char 		*note_dir;		/* path to note directory	*/
	char		*addr_dir;		/* where adddresses are stored */
	char		*tmp_dir;		/* path to tmp directory	*/
	char		*xpm_dir;		/* path to xpm files	*/
	char 		*print_cmd;		/* print command (using printf format) */
	char 		*calendar_cmd;	/* calendar command */
	char 		*email_cmd;		/* email command */
	char 		*email_addr;	/* default email address to mail to */
	char 		*home_dir;		/* default home directory */
	char 		*debugfile;		/* debug output file */
#ifdef DO_GTK
	int 		debuglevel;		/* debug level to use */
#else
	char 		*debuglevel;	/* debug level to use */
#endif
	char		*config_file;	/* config file name */
	char		*gtk_rc;			/* Gtk rc config file */
	char		*audio_cmd;		/* how to play audio files */
	char		*audio_dir;		/* where audio files are located */
	char		noaudio;			/* turn off audio for alarms */
	char		install;			/* when true, install private colormap */
	char		no_tips;			/* when true, don't use Tool Tips */
	char		*rgb_file;		/* path to rgb.txt file */
	char		*pilot_xfer;	/* NULL if Pilot "pilot_xfer" not found */
	char		*pilot_addr;	/* NULL if Pilot "addresses" not found */
	char		*pilot_memos;	/* NULL if Pilot "memos" not found */
	char		*pilot_imemos;	/* NULL if Pilot "install-memos" not found */
	char		*pilot_dir;		/* where pilot backups get stored */
} AppRes, *AppResPtr;

/*
 * Project configuration information.
 */
typedef struct _project_type{
	int	id;			/* unique id */

#ifdef DO_MOTIF
	char		*color;	/* background color for notes in this project */
#else
	gdouble	color[4];/* background color for notes in this project */
#endif

	char		*name;	/* name to use for this project */
	char		*dir;		/* directory to use for this project's notes */
	struct _project_type	*next;
} ProjectType;

/*
 * Audio file configuration information.
 */
typedef struct _af {
	int			id;		/* unique index */
	char			*file;	/* audio file name */
	char			type;		/* audio file type */
	struct _af	*next;	/* pointer to next link */
} AudioFileType;

/*
 * The list of hidden notes
 */
#ifdef DO_GTK
typedef struct {
	gchar			*name;	/* string used in menu button */
	GtkWidget	*widget;	/* button in menu for hidden note */
} ItemList;
#else
typedef struct {
	char			*name;	/* string used in menu button */
	Widget		widget;	/* button in menu for hidden note */
} ItemList;
#endif

/*
 * link lists of notes
 */
typedef struct pnlinks{
	StickyNote	*pn;
	int			x;			/* x coord of last note */
	int			y;			/* y coord of last note */
	struct pnlinks	*next;
}PNLinks;

/*
 * Upper or Lower case request types for ALConvertCase()
 */
typedef enum {
	AL_UPPER,
	AL_LOWER
} AL_CASE_TYPE;

/*
 * PailmPilot Address records.
 */
typedef struct _pilotaddr_t {
	struct _pilotaddr_t		*next;
	char	*last;
	char	*first;
	char	*title;
	char	*company;
	char	*work;
	char	*home;
	char	*fax;
	char	*other;
	char	*email;
	char	*address;
	char	*city;
	char	*state;
	char	*zip;
	char	*country;
	char	*custom1;
	char	*custom2;
	char	*custom3;
	char	*custom4;
	char	*note;
	char	*private;
	char	*category;
} PilotAddr_T;

/*
 * GTK can't run a widgets list of children in 1.0.1.  So generic.c needs
 * a datastructure to pass back widget ids.
 */
#ifdef DO_GTK
typedef struct _gshell_t {
	GtkWidget	*shell_id;
	GtkWidget	*vbox;
	GtkWidget	*accept;
	GtkWidget	*cancel;
	GtkWidget	*overwrite;
	GtkWidget	*append;
	GtkWidget	*help;
} GShell_T;
#endif


/*
 * External variable declarations.
 */
extern	AppRes app_res;
extern	unsigned long timer_interval;
extern	unsigned long alarm_interval;

#ifdef DO_GTK
extern	GtkWidget *listwidget;
extern	GtkWidget *menuwidget;
extern	GtkWidget *plaidwidget;
#else
extern	Widget 	listwidget;
extern	Widget 	menuwidget;
extern	Widget 	plaidwidget;
#endif

/*
 * If you're SYSV system doesn't have bcopy(), bzero(), or rindex()
 */
#ifdef SYSV_USE_MEMSET
#undef bzero
#define bzero(a,b) memset(a,0,b)
#undef bcopy
#define bcopy(a,b,c) memcpy(b,a,c)
#undef rindex
#define rindex(a,b) strrchr(a,b)
#else
 extern char *rindex();
#endif /* SYSV_USE_MEMSET */


/*========================================================================
 * Include all other header files here.   Makes it easier on the rest
 * of the .c files.
 *=======================================================================*/
#include "prototypes.h"
#include "version.h"
#include "err_text.h"

#ifdef DO_GTK
#include "getopt.h"
#endif

#endif /* XP_H */
