/* $Id$ */
/*========================================================================
 *  Copyright (c) Michael J. Hammel 1995,1996,1997,1998.
 *========================================================================
 *              FILE NAME: getopt.h
 *            DESCRIPTION: declarations for getopt parser
 *  SOFTWARE DEPENDENCIES: 
 *  HARDWARE DEPENDENCIES: 
 *                  NOTES: 
 *
 * SPECIAL CONSIDERATIONS:
 * This file is easiest to read with tabstops set to 3
 *
 *========================================================================
 *
 * MODIFICATION HISTORY:
 * $Log$
 *
 *========================================================================*/
#ifndef GETOPT_H
#define GETOPT_H

#ifndef GETOPT_C
extern char	getopt_long();
extern int	opterr;
extern int	optindex;
extern char	*optarg;
#endif

typedef struct _option {
	char		*option_name;
	int		use_optarg;
	int		dummy1;
	int		dummy2;
} option;

/*
 * If you're SYSV system doesn't have bcopy(), bzero(), or rindex()
 */
#ifdef SYSV_USE_MEMSET
#undef bzero
#define bzero(a,b) memset(a,0,b)
#undef bcopy
#define bcopy(a,b,c) memcpy(b,a,c)
#undef rindex
#define rindex(a,b) strrchr(a,b)
#else
 extern char *rindex();
#endif /* SYSV_USE_MEMSET */

#endif /* GETOPT_H */
