/* $Id$ */

/*========================================================================
 *  Copyright (c) Michael J. Hammel 1995,1996,1997,1998.
 *========================================================================
 *              FILE NAME: prototypes.h
 *            DESCRIPTION: External function definitions
 *                  NOTES: 
 *
 * SPECIAL CONSIDERATIONS:
 *========================================================================
 *
 * MODIFICATION HISTORY:
 * $Log$
 *
 *========================================================================*/
#ifndef XP_PROTOS_H
#define XP_PROTOS_H

#ifndef XP_NOTES_C
extern void XPCreateNewNote();
extern void XPRaiseNotes();
extern void XPRaiseAllNotes();
extern void XPLowerNotes();
extern void XPLowerAllNotes();
extern void XPSaveAllNotes();
extern void XPUnHideAllNotes();
extern void XPHideAllNotes();
extern void XPCascadeNotes();
extern void XPMakeNoteListCB();
extern void	XPMakeNoteWidget();
extern void XPAnchorNote();
extern void XPUnAnchorNote();
extern void	XPDestroyNote();
extern void	XPSetSaveSensitive();
extern void	XPTearOff();
extern void XPHideNote();
extern void XPEraseNote();
extern void XPSaveNote();
extern void XPGetNotePosition();
extern StickyNote	*XPFindNote();
extern StickyNote	*XPAllocNote();
#endif


#ifndef XP_BINDINGS_C
extern void XPActionAlarm();
extern void XPActionAnchor();
extern void XPActionDestroy();
extern void XPActionHide();
extern void XPActionErase();
extern void XPActionCal();
extern void XPActionSave();
extern void XPActionPrint();
extern void XPActionOpen();
extern void XPActionEnvelope();
extern void XPActionProject();
#endif


#ifndef XP_MENUS_C
extern void XPCreateMainMenu();
extern int XPButtonPress();
#endif


#ifndef XP_UTILS_C
extern void			*XPInsertText();
extern void			XPShutdown();
extern void			XPCenterWindow();

#ifdef DO_GTK
extern GtkWidget	*XPMultiLineText();
extern GtkWidget	*XPGtkNameToWidget();
extern int			XPNoop2();
extern void			XPGTKShowDisabledCmds();
extern int			XPFind();
#else
extern Widget		*XPMultiLineText();
#endif

#ifdef DO_MOTIF
extern void			XPPopUpWindow();
#endif
#endif /* XP_UTILS_C */


#ifndef XP_PLAID_C
#ifdef DO_GTK
extern GtkWidget	*XPCreatePlaidWidget();
#else
extern Widget		XPCreatePlaidWidget();
#endif
#endif /* XP_PLAID_C */


#ifndef XP_LOADSAVE_C
extern void	XPLoadSavedNotes();
#endif

#ifndef XP_TT_C
extern void	XPToolTips();
#endif

#ifndef XP_FINDTEXT_C
extern void	XPFindTextPrompt();
#endif

#ifndef XP_PROJECTS_C
extern void	XPProject();
extern void	XPNoteProject();
extern void	XPUpdateColorBox();
#endif

#ifndef XP_TIMERCB_C
extern void	XPAutoSave();
extern void	XPAlarmCheck();
extern void	XPCreateTimerPrompt();
extern void XPAlarmOff();
#endif


#ifndef XP_ERRDIALOG_C
extern void XPErrPopDown();
#endif


#ifndef XP_FINDNOTE_C
extern void	XPCreateFindNotePrompt();
#endif

#ifndef XP_CONFIRM_C
extern void	XPConfirmIt();
extern void	XPConfirmDialogClose();
#endif


#ifndef XP_COLORS_C
extern int	XPSetGlobalColors();
#endif


#ifndef XP_IO_C
extern void	XPOpenNote();
extern void	XPExportNote();
#endif


#ifndef XP_PRINT_C
extern void	XPPrintNote();
#endif


#ifndef XP_NAME_C
extern void	XPNameNote();
#endif


#ifndef XP_INSERTS_C
extern void	XPInsertDates();
extern void	XPInsertCalendar();
#endif


#ifndef XP_EMAIL_C
extern void	XPCreateEmailNotePrompt();
#endif


#ifndef XP_CONFIG_C
extern void	XPReadConfigFile();
#endif


#ifndef XP_AUDIO_C
extern void	XPSetUpAudio();
#endif


#ifndef XP_ENVELOPE_C
extern void	XPEnvelope();
#endif

#ifndef XP_DIALOG_C
extern void	XPMsgWindow();
#endif

#ifndef XP_ABOUT_C
extern int XPAbout();
#endif

#ifndef XP_PILOT_C
extern void XPPilot();
#endif

#ifndef XP_PADDR_C
extern int XPPilotParseAddr();
#endif

#ifndef XP_GENERIC_C
#ifdef DO_GTK
extern GtkWidget	*XPCreateGenericShell();
#else
extern Widget		XPCreateGenericShell();
#endif
#endif


/*
 * Motif Specific Routines.
 */
#ifdef DO_MOTIF

#ifndef XPIXMAP_C
extern void	XPCreatePixmap();
#endif

#endif /* End of Motif specific routines */


/*
 * Common files (in libxncommon)
 */
#ifndef XP_CUTILS_S
extern char			*XPSafeAlloc();
extern void			*XPSetNoteDir();
extern char			*XPMakeFname();
extern void 		XPPopUpList();
extern void			XPNoop();
extern void			XPRingBell();
extern void			XPErrPopUp();
extern void			XPShowDisabledCmds();
extern int			XPTestCmd();
extern void			XPFixUpPath();
extern void			XPConvertCase();
#endif

#ifndef XP_C_C
extern void			XPValidateAppRes();
extern void			XPShowDefaults();
#endif

#ifndef XP_CPROJECTS_S
extern void	XPSetUpProjects();
extern void	XPWriteProjects();
#endif

#endif /* XP_PROTOS_H */
