#!/usr/bin/ksh -p

# Convert a yrolo database to CSV for upload to a PalmPilot.
# Michael J. Hammel
#
# You need to convert all of the ^L lines to "--" first!  The following vi
# command will do that for you:
#
# :1,$s//--/
#
# Note that the ^L above is a *real* control sequence, not just a caret
# followed by an L!  If you want to enter this by hand in vi you type
# CTRL-vCTRL-L.  The CTRL-v won't print anything, but accepts the next
# character as a control character.

input=/tmp/yrolo.yr
output=/tmp/pilot.yr

> $output

count=1
init=1

while read 
do
	line=`echo "$REPLY"`
	if [ $init -gt 2 ]
	then
		echo "reply: $line"
	
		case $count in 
		1)
			name=`echo $line`
			# echo "name: $name"
			;;
		2)
			company=`echo $line`
			;;
		3)
			addr1=`echo $line`
			;;
		4)
			addr2=`echo $line`
			;;
		5)
			home=`echo $line`
			;;
		6)
			work=`echo $line`
			;;
		7)
			fax=`echo $line`
			;;
		8)
			other=`echo $line`
			;;
		*)
			if [ "$line" = "--" ]
			then
				printf \
					"\"%s\", \"\", \"\", \"%s\", \"%s\", \"%s\", \"%s\", \"\", \"%s\", \"%s\", \"%s\", \"\", \"\", \"\", \"\", \"\", \"\", \"\", \"%s\", 0, \"\"\n " \
					"$name" "$company" "$work" "$home" "$fax" \
					"$email" "$addr1" "$addr2" "$note" \
					>> $output
				count=0
				init=2
				note=""
			else
				note=`echo "$note\n$line"`
			fi
			;;
		esac
	
		count=`expr $count + 1`

	else

		echo "skipping: $line"
		init=`expr $init + 1`

	fi

done < $input
