/* $Id$ */

/*========================================================================
 *  Copyright (c) Michael J. Hammel 1995, 1996, 1997, 1998.
 *========================================================================
 *              FILE NAME: about.c 
 *            DESCRIPTION: gratuitous self-promotion
 *      DEFINED CONSTANTS: 
 *       TYPE DEFINITIONS: 
 *      MACRO DEFINITIONS: 
 *       GLOBAL VARIABLES: 
 *       PUBLIC FUNCTIONS: XPAbout
 *      PRIVATE FUNCTIONS: 
 *  SOFTWARE DEPENDENCIES: 
 *  HARDWARE DEPENDENCIES: 
 *                  NOTES: 
 *
 * SPECIAL CONSIDERATIONS:
 * Set your tabstops to 3 to make the code more readable.
 *========================================================================
 *
 * MODIFICATION HISTORY:
 * $Log$
 *
 *========================================================================*/
#define XP_ABOUT_C

/* === System Headers === */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gtk/gtk.h>


/* === Project Headers === */
#include "XNotesPlus.h"
#include "debug.h"


/* === external routines === */


/* === Public routine prototypes === */


/* === Private routine prototypes === */
static void		ClearAbout();


/* === Global Variables === */

/* === Static Variables === */
static GtkWidget		*aboutwidget;


/*========================================================================
 *	Name:			XPAbout
 *	Prototype:	XPAbout()
 *					
 *	Description:
 * Put up a window that says who I am and what this thing is.
 *
 *	Input Arguments:
 *	Output Arguments:
 *	Return Values:
 *	Global Variables:
 *	External Routines:
 *	Method:
 *	Restrictions:
 *	Notes:
 *========================================================================*/
void
XPAbout(
)
{
#ifdef DEBUG
	char	fname[]="XPAbout";
#endif

	GtkWidget		*vbox;
	GtkWidget		*cancel_button;
	GtkWidget		*title, *info;

	char				*msg=XP_S_PROG_NAME;
	char				*msg2;

	GShell_T			gshell;


	/*
	 * Allow only one copy at a time.
	 */
	if ( aboutwidget != NULL )
		return;

	/*
	 * Create a dialog, set its title, and position it at the cursor.
	 */
	DBGPrintf(DBG_INFO,("Creating find dialog.\n"));
	aboutwidget = XPCreateGenericShell(AboutDialog, CANCEL_BUTTON, 
							&gshell, TRUE );

	gtk_signal_connect (GTK_OBJECT (aboutwidget), "destroy",
			GTK_SIGNAL_FUNC (ClearAbout), NULL);

	/*
	 * Get the widget ids of the various parts of the window.
	 */
	vbox = gshell.vbox;
	cancel_button = gshell.cancel;

	/*
	 * A set of labels for descriptive info and pixmaps
	 */
	title = gtk_label_new(msg);
	gtk_widget_set_name(title, "title");
	gtk_widget_show(title);
	gtk_container_add(GTK_CONTAINER(vbox), title);


	msg2 = (char *)XPSafeAlloc(strlen(XP_S_ABOUT_INFO) + strlen(VERSION) + 1);
	strcpy(msg2, VERSION);
	strcat(msg2, XP_S_ABOUT_INFO);
   info = gtk_label_new(msg2);
	gtk_widget_show(info);
	gtk_container_add(GTK_CONTAINER(vbox), info);
	free(msg2);

	/*
	 * Cancellation button.
	 */
	gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
			GTK_SIGNAL_FUNC (ClearAbout), NULL);

	/*
	 * Stick the dialog in the middle of the display.
	 */
	gtk_widget_realize( aboutwidget );
	XPCenterWindow(aboutwidget, NULL, aboutwidget);
	gtk_widget_show(aboutwidget);

}

/*
 * ClearAbout - get rid of the confirmation box.
 */
static void
ClearAbout()
{
	if ( aboutwidget != NULL )
	{
		gtk_widget_destroy( aboutwidget );
		aboutwidget = NULL;
	}
}

