/* $Id$ */

/*========================================================================
 *  Copyright (c) Michael J. Hammel 1995, 1996, 1997, 1998.
 *========================================================================
 *              FILE NAME: about.c 
 *            DESCRIPTION: gratuitous self-promotion
 *      DEFINED CONSTANTS: 
 *       TYPE DEFINITIONS: 
 *      MACRO DEFINITIONS: 
 *       GLOBAL VARIABLES: 
 *       PUBLIC FUNCTIONS: XPAbout
 *      PRIVATE FUNCTIONS: 
 *  SOFTWARE DEPENDENCIES: 
 *  HARDWARE DEPENDENCIES: 
 *                  NOTES: 
 *
 * SPECIAL CONSIDERATIONS:
 * Set your tabstops to 3 to make the code more readable.
 *========================================================================
 *
 * MODIFICATION HISTORY:
 * $Log$
 *
 *========================================================================*/
#define XP_ABOUT_C

/* === System Headers === */
#include <stdio.h>
#include <stdlib.h>
#include "motif.h"


/* === Project Headers === */
#include "XNotesPlus.h"
#include "debug.h"


/* === external routines === */


/* === Public routine prototypes === */


/* === Private routine prototypes === */
static void		ClearAbout();


/* === Global Variables === */

/* === Static Variables === */
static Widget		aboutwidget;


/*========================================================================
 *	Name:			XPAbout
 *	Prototype:	XPAbout()
 *					
 *	Description:
 * Put up a window that says who I am and what this thing is.
 *
 *	Input Arguments:
 *	Output Arguments:
 *	Return Values:
 *	Global Variables:
 *	External Routines:
 *	Method:
 *	Restrictions:
 *	Notes:
 *========================================================================*/
void
XPAbout(
)
{
#ifdef DEBUG
	char	fname[]="XPAbout";
#endif

	Widget			vbox;
	Widget			cancel_button;
	Widget			title, info;
	XmString			xm_string;
	char				buf[256];
	Arg				args[5];
	int				nargs;
	Dimension		width, height;
	char				*msg=XP_S_PROG_NAME;
	char				*msg2;


	/*
	 * Allow only one copy at a time.
	 */
	if ( aboutwidget != NULL )
		return;

	/*
	 * Create a dialog, set its title, and position it at the cursor.
	 */
	DBGPrintf(DBG_INFO,("Creating find dialog.\n"));
	aboutwidget = XPCreateGenericShell(AboutDialog, CANCEL_BUTTON );

	/*
	 * Get the widget ids of the various parts of the window.
	 */
	sprintf(buf, "*GenericForm%d", (int)aboutwidget );
	vbox = XtNameToWidget(aboutwidget, buf);
	sprintf(buf, "*GenericCancelB%d", (int)aboutwidget);
	cancel_button = XtNameToWidget(aboutwidget, buf);
 
	/*
	 * A set of labels for descriptive info and pixmaps
	 */
	xm_string=XmStringCreate(msg, "HUGE_BOLD");
	nargs=0;
	XtSetArg ( args[nargs], XmNlabelString, xm_string ); nargs++;
   XtSetArg ( args[nargs], XmNleftAttachment, XmATTACH_FORM); nargs++;
   XtSetArg ( args[nargs], XmNrightAttachment, XmATTACH_FORM); nargs++;
   XtSetArg ( args[nargs], XmNtopAttachment, XmATTACH_FORM); nargs++;
	title = XmCreateLabel(
					vbox,
					"title",
					args, nargs
					);
	XtManageChild(title);
	XmStringFree(xm_string);

	msg2 = (char *)XPSafeAlloc(strlen(XP_S_ABOUT_INFO) + strlen(VERSION) + 1);
	strcpy(msg2, VERSION);
	strcat(msg2, XP_S_ABOUT_INFO);
	XPMultiLineText(msg2, &xm_string);
	nargs=0;
	XtSetArg ( args[nargs], XmNlabelString, xm_string ); nargs++;
   XtSetArg ( args[nargs], XmNleftAttachment, XmATTACH_FORM); nargs++;
   XtSetArg ( args[nargs], XmNrightAttachment, XmATTACH_FORM); nargs++;
   XtSetArg ( args[nargs], XmNtopAttachment, XmATTACH_WIDGET); nargs++;
   XtSetArg ( args[nargs], XmNtopWidget, title); nargs++;
	info = XmCreateLabel(
					vbox,
					"info",
					args, nargs
					);
	XtManageChild(info);
	XmStringFree(xm_string);
	free(msg2);

	/*
	 * Cancellation button.
	 */
	XtAddCallback( cancel_button, XmNactivateCallback, 
			ClearAbout, (XtPointer)NULL);

	/*
	 * Stick the dialog in the middle of the display.
	 */
	XtRealizeWidget( aboutwidget );
	XPCenterWindow(aboutwidget, NULL, aboutwidget);

	XtPopup(aboutwidget, XtGrabNone);

	/*
	 * This bit of code forces the pop up window to stay its
	 * initial size, despite the users attempts to resize it.
	 * By doing this, I avoid having to muck extensively with
	 * aligning objects after a resize.
	 */
	nargs = 0;
	XtSetArg ( args[nargs], XmNwidth, &width); nargs++;
	XtSetArg ( args[nargs], XmNheight, &height); nargs++;
	XtGetValues ( aboutwidget, args, nargs);
	nargs = 0;
	XtSetArg ( args[nargs], XmNmaxWidth, width); nargs++;
	XtSetArg ( args[nargs], XmNmaxHeight, height); nargs++;
	XtSetArg ( args[nargs], XmNminWidth, width); nargs++;
	XtSetArg ( args[nargs], XmNminHeight, height); nargs++;
	XtSetValues ( aboutwidget, args, nargs); 

}

/*
 * ClearAbout - get rid of the confirmation box.
 */
static void
ClearAbout()
{
	if ( aboutwidget != NULL )
	{
		XtDestroyWidget( aboutwidget );
		aboutwidget = NULL;
	}
}

