/* $Id$ */

/*========================================================================
 *  Copyright (c) Michael J. Hammel 1995,1996,1997,1998.
 *========================================================================
 *              FILE NAME: plaid.c
 *            DESCRIPTION: Create top level windows, plaid button
 *      DEFINED CONSTANTS: 
 *       TYPE DEFINITIONS: 
 *      MACRO DEFINITIONS: 
 *       GLOBAL VARIABLES: 
 *       PUBLIC FUNCTIONS: XPCreatePlaidWidget
 *      PRIVATE FUNCTIONS: 
 *  SOFTWARE DEPENDENCIES: 
 *  HARDWARE DEPENDENCIES: 
 *                  NOTES: 
 *
 * SPECIAL CONSIDERATIONS:
 * Set your tabstops to 3 to make the code more readable.
 *========================================================================
 *
 * MODIFICATION HISTORY:
 * $Log$
 *
 *========================================================================*/
#define XP_PLAID_C

/* === System Headers === */
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "motif.h"

/* === Project Headers === */
#include "XNotesPlus.h"

/* === external routines === */

/* === Public routine prototypes === */

/* === Private routine prototypes === */

/* === Global Variables === */
Widget	Top_Level;


/*========================================================================
 *	Name:			XPCreatePlaidWidget
 *	Prototype:	Widget XPCreatePlaidWidget()
 *					
 *	Description:
 *	Create the plaid widget, the top level button from which the user
 *	initiates all note actions.
 *
 *	Input Arguments:
 *	Output Arguments:
 *	Return Values:
 *		Widget		the visible widget (a button)
 *
 *	Global Variables:
 *	External Routines:
 *	Method:
 *	Restrictions:
 *	Notes:
 *		
 *========================================================================*/
Widget 
XPCreatePlaidWidget()
{
	Widget		button;
	Arg			args[15];
	int			nargs;

	XpmAttributes	attributes;
	Pixmap			*plaid_xpm;


	/*
	 * Create the top level window and set it up to properly exit on
	 * a delete request from the OS or Window Manager.  Then set the
	 * title for the window (which for most people will probably never
	 * get used) and set the internal border width (for any widgets we
	 * pack inside) to 0 (so they butt up against the edges of our main
	 * window).
	 */

	/*
	 * Motif version:
	 * 1. form
	 * 2. button
	 * 3. plaid image inside button.
	 */
 
	/*
	 * Create the plaid pixmap.
	 */
   XPCreatePixmap(&plaid_xpm, NULL, XP_PLAID_XPM, &attributes, Top_Level);

	/*
	 * Create a button and stuff it inside of the form.
	 */
	nargs = 0;
	XtSetArg ( args[nargs], XmNleftAttachment, XmATTACH_FORM); nargs++;
	XtSetArg ( args[nargs], XmNrightAttachment, XmATTACH_FORM); nargs++;
	XtSetArg ( args[nargs], XmNtopAttachment, XmATTACH_FORM); nargs++;
	XtSetArg ( args[nargs], XmNbottomAttachment, XmATTACH_FORM); nargs++;
	XtSetArg ( args[nargs], XmNlabelType, XmPIXMAP); nargs++;
	XtSetArg ( args[nargs], XmNlabelPixmap, plaid_xpm); nargs++;
	XtSetArg ( args[nargs], XmNhighlightThickness, 0); nargs++;
	button = XtCreateManagedWidget(
				"logo",
				xmPushButtonWidgetClass,
				Top_Level,
				args, nargs
				);

	/*
	 * Return the id of the button.
	 */
	return(button);
}
