namespace eval menubar {
    variable menu
}

proc menubar::create { } {
    global tkWorld
    variable menu

    set mbar [menu .menubar \
	    -tearoff 0]
    . configure -menu $mbar

    set tkworld [menu $mbar.tkworld \
	    -tearoff 0]
    $mbar add cascade \
	    -label tkWorld \
	    -menu $tkworld \
	    -underline 0
    $tkworld add command \
	    -label Exit \
	    -command {destroy .} \
	    -underline 1

    set cmd [menu $mbar.cmd -tearoff 0]
    $mbar add cascade \
	    -label "Command Center" \
	    -menu $cmd \
	    -underline 0

    foreach c "Stop Run Reset Pipe History Shell" {
	set x cmd_center::[string tolower $c]
	set u 0
	if {$c == "Reset"} {
	    set x history::create
	    set u 2
	}
	$cmd add command \
		-label $c \
		-command $x \
		-underline $u
    }

    set lw [menu $mbar.lw -tearoff 0]
    $mbar add cascade \
	    -label "Log Window" \
	    -menu $lw \
	    -underline 0

    foreach c "Clear Home Up Down End Save" {
	set x log_window::[string tolower $c]
	set u 0
	$lw add command \
		-label $c \
		-command $x \
		-underline $u
    }
    
    set balloon [menu $mbar.balloon -tearoff 0]
    $mbar add cascade \
	    -label Balloon \
	    -menu $balloon \
	    -underline 0
    $balloon add command \
	    -label On \
	    -command {set balloonhelp::balloonhelp(active) 1} \
	    -underline 1
    $balloon add command \
	    -label Off \
	    -command {set balloonhelp::balloonhelp(active) 0} \
	    -underline 1

    set help [menu $mbar.help -tearoff 0 -borderwidth 1]
    $mbar add cascade \
	    -label Help \
	    -menu $help \
	    -underline 0
    $help add command \
	    -label About \
	    -command about::create \
	    -underline 0
    $help add separator
    $help add command \
	    -label Help \
	    -command help::create \
	    -underline 0
}